local cql = ClassicQuestLog

ClassicQuestLogMinimapButtonMixin = {}

function ClassicQuestLogMinimapButtonMixin:Setup()
    self:Update()
    self:RegisterForDrag("LeftButton")
    self:SetFrameLevel(Minimap:GetFrameLevel()+2)
    if cql.options:Get("ShowMinimapButton") then
        self:Show()
    end
end

function ClassicQuestLogMinimapButtonMixin:Update()
    local angle = cql.options:Get("MinimapPosition") or 116
    self:SetPoint("CENTER",Minimap,"CENTER",(105*cos(angle)),(105*sin(angle)))
end

function ClassicQuestLogMinimapButtonMixin:OnEnter()
    GameTooltip:SetOwner(self,"ANCHOR_LEFT")
    GameTooltip:AddLine("\124cffffffffClassic Quest Log")
    GameTooltip:AddLine("Version "..GetAddOnMetadata("Classic Quest Log","Version"))
    GameTooltip:Show()
end

function ClassicQuestLogMinimapButtonMixin:OnLeave()
    GameTooltip:Hide()
end

function ClassicQuestLogMinimapButtonMixin:OnMouseDown()
    self.Icon:SetPoint("CENTER",0,-2)
    self.Icon:SetVertexColor(0.65,0.65,0.65)
end

function ClassicQuestLogMinimapButtonMixin:OnMouseUp()
    self.Icon:SetPoint("CENTER",1,0)
    self.Icon:SetVertexColor(1,1,1)
end

function ClassicQuestLogMinimapButtonMixin:OnClick()
    cql:ToggleWindow()
end

function ClassicQuestLogMinimapButtonMixin:OnDragStart()
    self:SetScript("OnUpdate",self.OnDragUpdate)
end

function ClassicQuestLogMinimapButtonMixin:OnDragStop()
    self:OnMouseUp()
    self:SetScript("OnUpdate",nil)
end

function ClassicQuestLogMinimapButtonMixin:OnDragUpdate()
	local x,y = GetCursorPosition()
	local scale = Minimap:GetEffectiveScale()
    local minX,minY = Minimap:GetCenter()
    cql.options:Set("MinimapPosition",math.deg(math.atan2(y/scale-minY,x/scale-minX)))
    self:Update()
end
